#!/usr/bin/env python
# -*- coding: utf-8 -*-
##
##    Copyright (C) 2009 manatlan manatlan[at]gmail(dot)com
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 2 only.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## More infos : http://www.manatlan.com/page/totem-plugin-flux
##

from datetime import datetime
import locale


def str2date(s):
    s=s.split(" +")[0]

    loc = locale.getlocale() # get current locale
    locale.setlocale(locale.LC_TIME, (None,None))
    try:
        d= datetime.strptime(s,"%a, %d %b %Y %H:%M:%S")
    except:
        d=None
    finally:
        locale.setlocale(locale.LC_TIME, loc)
    return d

def tz2date(s):
    loc = locale.getlocale() # get current locale
    locale.setlocale(locale.LC_TIME, (None,None))
    try:
        d= datetime.strptime(s,"%Y-%m-%dT%H:%M:%S.000Z")
    except:
        d=None
    finally:
        locale.setlocale(locale.LC_TIME, loc)
    return d


if __name__ == "__main__":
    assert str(str2date("Mon, 18 May 2009 13:35:35 +0100"))=="2009-05-18 13:35:35"
    assert str2date("Monroe, 18 May 2009 13:35:35 +0100")==None

    assert str(tz2date("2007-09-29T17:04:02.000Z"))=="2007-09-29 17:04:02"
    assert tz2date("2007-09-29X17:04:02.000Z")==None
