#!/usr/bin/env python
# -*- coding: utf-8 -*-
##
##    Copyright (C) 2009 manatlan manatlan[at]gmail(dot)com
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 2 only.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## More infos : http://www.manatlan.com/page/totem-plugin-flux
##

import thread
class RunProc(object):
    def __init__(self,func, args=None,kargs=None):
        if args is None: args=()
        if kargs is None: kargs={}
        def _pq(self,func,args,kargs):
            self.__lock.acquire()
            self.__ret = func(*args,**kargs)
            self.__lock.release()
        self.__lock=thread.allocate_lock()
        thread.start_new_thread(_pq,(self,func,args,kargs))
        while not self.isRunning(): pass
    def isRunning(self):
        return self.__lock and self.__lock.locked()
    def get(self):
        if self.__lock:
            self.__lock.acquire()
            self.__lock=None
        return self.__ret
    def kill(self):
        pass


if __name__ == '__main__':
    
    def work(s,n,cb=None):
        import time
        time.sleep(s)
        l=range(n)
        if cb:  cb(l)
        return l
    
    
    def mycb(l):
        print "***cb:",l
    
    
    p2=RunProc( work, (2,6) )
    assert p2.isRunning()
    v1=p2.get()
    assert not p2.isRunning()
    v2=p2.get()
    assert v1==v2
    assert not p2.isRunning()

    p1=RunProc( work, (3,13),{"cb":mycb} )
    p2=RunProc( work, (2,6) )

    assert p1.isRunning()
    assert p2.isRunning()

    assert len(p1.get()) == 13
    assert len(p2.get())==6

    assert not p1.isRunning()
    assert not p2.isRunning()
    print "ok"