#!/usr/bin/env python
# -*- coding: utf-8 -*-
##
##    Copyright (C) 2009 manatlan manatlan[at]gmail(dot)com
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 2 only.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## More infos : http://www.manatlan.com/page/totem-plugin-flux
##


import urllib
import urllib2
import os
import tempfile
import datetime

def mkRequest(url,data=None,headers=None):
    """ create a urlib2.Request """
    if data:
        data = urllib.urlencode(data)
    if headers is None:
        headers={
            "User-Agent":"Mozilla/5.0 (Windows; U; Windows NT 5.1; fr; rv:1.9.0.10) Gecko/2009042316 Firefox/3.0.10",
            "Accept":"text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8",
            "Accept-Language":"fr,en;q=0.8,fr-fr;q=0.5,en-us;q=0.3",
            #"Accept-Encoding":"gzip,deflate",
            "Accept-Charset":"ISO-8859-1,utf-8;q=0.7,*;q=0.7",
            "Keep-Alive":"300",
            "Proxy-Connection":"keep-alive"
            }
    return urllib2.Request(url,data,headers)

def getUrl(url,data=None,headers={}):
    request = mkRequest(url,data,headers)
    response = urllib2.urlopen(request)
    return response.read()

def getFilePage(url,cache=0):
    file=url.replace(":","_")
    file=file.replace("/","_")
    file=os.path.join( tempfile.gettempdir() ,file)

    if cache:
        if os.path.isfile(file):
            # le fichier existe, on va comparer dates
            now = datetime.datetime.now()
            d=datetime.datetime.fromtimestamp(os.stat(file).st_mtime)
            useCache = (now < d + datetime.timedelta(seconds=cache))
        else:
            useCache=False
    else:
        useCache=False

    if not useCache:
        buf=getUrl(url)
        open(file,"w+").write(buf)

    return file

if __name__ == "__main__":
    #~ print getUrl("http://google.fr")
    #~ print getFilePage("http://google.fr")
    u="http://www.youtube.com/"
    request = mkRequest(u)
    response = urllib2.urlopen(request)
    assert len(response.read(1000))==1000
